package com.ruoyi.web.controller.topology;

import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.file.FileUploadUtils;
import com.ruoyi.topology.service.IimagesService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;

/**
 * @author jianglw
 * @version 1.0
 * @date 2021/6/17 8:51
 */
@RestController
@Slf4j
@RequestMapping("/images")
public class ImagesController {
    @Autowired
    private IimagesService iimagesService;

    /**
     * 上传图片
     * @param file
     * @return
     * @throws IOException
     */
    @RequestMapping("/upload")
    public AjaxResult upload(@RequestParam("imgFile") MultipartFile file) throws IOException {
        if (!file.isEmpty()) {
            String img = FileUploadUtils.upload( RuoYiConfig.getProfile()+ Constants.IMG_PATH, file);
            if(iimagesService.addImages( img )>0){
                return AjaxResult.success();
            }
        }
        return AjaxResult.error("图片不存在，请检查文件是否正确");
    }

    /**
     * 获取图片
     * @return
     */
    @RequestMapping("/list")
    public AjaxResult list(){
        return AjaxResult.success(iimagesService.getImages());
    }

    /**
     * 删除图片
     * @param id
     * @return
     */
    @DeleteMapping("/delete/{id}")
    public AjaxResult delete(@PathVariable("id") Integer id){
        if(iimagesService.deleteImages( id )>0){
            return AjaxResult.success();
        }
        return AjaxResult.error("删除图片失败");
    }
}
