package com.ruoyi.common.topology.change;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.enums.NodeLineParams;
import com.ruoyi.common.topology.handletype.NodeLineParamsInt;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.spring.SpringUtils;
import org.springframework.data.redis.core.StringRedisTemplate;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 * @author jianglw
 * @version 1.0
 * @date 2021/4/26 9:41
 */
public class PointAndData {

    /**
     * 组装数据
     * @param map
     * @param jsonArray
     * @param id
     * @return
     */
    public static List<Map<String,Object>> assemble(Map<String,Object> map, JSONArray jsonArray,String id){
        List<ChangeSub> list=jsonArray.toJavaList( ChangeSub.class );
        List<Map<String,Object>> list1=new LinkedList<>(  );
        for(ChangeSub changeSub:list){
            List<Handle> handleList=changeSub.getHandle();
            list1.add( handle( map,handleList,changeSub.getTag(),changeSub.getEcharts(),id ) );
        }
        return list1;
    }

    /**
     *
     * @param map
     * @param list
     * @param tag
     * @param echarts
     * @param id
     * @return
     */
    private static Map<String, Object> handle(Map<String,Object> map, List<Handle> list, String tag,String echarts,String id){
        //存储map
        Map<String, Object> map1 =new HashMap<>(  );
        for(Handle handle:list){
            NodeLineParamsInt nodeLineParamsInt= NodeLineParams.match( handle.getType() );
            nodeLineParamsInt.getDataToParams( handle,map,map1,echarts,id );
        }
        if(StringUtils.isNotBlank( echarts )){
            StringRedisTemplate stringRedisTemplate=SpringUtils.getBean( StringRedisTemplate.class );
            JSONObject jsonObject2=JSONObject.parseObject(stringRedisTemplate.opsForValue().get( Constants.TOPOLOGY_DATA+id ));
            JSONArray change=jsonObject2.getJSONObject( "topologyHandle" ).getJSONArray( "change" );
            for(int i=0;i<change.size();i++){
                if(tag.equals( change.getJSONObject(i).getString( "tag" ) )){
                    change.getJSONObject(i).put( "echarts",JSONObject.parseObject( map1.get( "data" ).toString() ).get( "echarts" ) );
                }
            }
            jsonObject2.getJSONObject( "topologyHandle" ).put( "change",change );
            stringRedisTemplate.opsForValue().set( Constants.TOPOLOGY_DATA+id,jsonObject2.toJSONString() );
        }
        map1.put( "tag", tag);
        return map1;
    }
}
