package com.ruoyi.common.topology.handletype;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.topology.change.AssembleData;
import com.ruoyi.common.topology.change.EchartsSet;
import com.ruoyi.common.topology.change.Handle;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.spring.SpringUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.data.redis.core.StringRedisTemplate;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 * 组装echarts数据
 *
 * @author jianglw
 * @version 1.0
 * @date 2021/6/1 17:26
 */
@Slf4j
public class DataParam implements NodeLineParamsInt {

    @Override
    public void getDataToParams(Handle handle, Map<String, Object> map, Map<String, Object> map1, String echarts,String id) {

        //判断是否为自定义图表
        if (!handle.getCustomChart()) {
            map1.put( handle.getType(), AssembleData.getData( handle, map ) );
        } else {
            if (StringUtils.isNotBlank( echarts )) {
                JSONObject jsonObject = JSONObject.parseObject( echarts );
                JSONObject jsonObject1 = JSONObject.parseObject( echarts ).getJSONObject( "option" );
                //组合title
                jsonObject1.getJSONObject( "title" ).put( "text", handle.getTitle() );
                List<String> list = new LinkedList<>();
                List<String> xList = new LinkedList<>();
                List<Map<String, Object>> seriesList = new LinkedList<>();
                Map<String, Object> map2 = null;
                //组合y轴及x轴
                for (EchartsSet echartsSet : handle.getEchartsArray()) {
                    if (echartsSet.getAxis().equals( "yAxis" )) {
                        map2 = new HashMap<>();
                        map2.put( "name", echartsSet.getName() );
                        map2.put( "type", echartsSet.getSeriesType() );
                        map2.put( "data", map.get( echartsSet.getPoint() ) + "" );
                        seriesList.add( map2 );
                        list.add( echartsSet.getName() );
                    }
                    if (echartsSet.getAxis().equals( "xAxis" )) {
                        xList.add( map.get( echartsSet.getPoint() ) + "" );
                    }
                }
                //组合y轴数据series
                JSONArray jsonArray = jsonObject1.getJSONArray( "series" );
//                if(jsonArray.size()==seriesList.size()){
                for (Map<String, Object> m : seriesList) {
                    for (int i = 0; i < jsonArray.size(); i++) {
                        JSONObject jsonObject2 = jsonArray.getJSONObject( i );
                        if (m.get( "name" ).equals( jsonArray.getJSONObject( i ).getString( "name" ) )) {
                            jsonObject2.getJSONArray( "data" ).add( m.get( "data" ) );
                        }else{
                            jsonObject2.put( "name",m.get( "name" ) );
                            List<Object> list1=new LinkedList<>();
                            list1.add( m.get( "data" ) );
                            jsonObject2.put( "data", list1);
                        }
                    }
                }

                if (jsonObject1.containsKey( "legend" )) {
                    jsonObject1.getJSONObject( "legend" ).put( "data", list );
                    jsonObject1.getJSONObject( "xAxis" ).getJSONArray( "data" ).add( xList.get( 0 ) );
                } else {
                    jsonObject1.put( "legend", new JSONObject() );
                    jsonObject1.getJSONObject( "legend" ).put( "data", list );
                    jsonObject1.getJSONObject( "xAxis" ).put( "data", xList );
                }
                jsonObject1.put( "series",jsonArray );
                jsonObject.put( "option",jsonObject1 );
                JSONObject newEcharts=new JSONObject();
                newEcharts.put( "echarts",jsonObject );
                map1.put( "data", newEcharts.toJSONString() );

            } else {
                log.debug( "未获取到组态中的图表信息" );
            }
        }
        //echarts 在canvas上刷新使用
        map1.put( "elementRendered", false );

    }
}
