package com.ruoyi.framework.publicinter;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.topology.mutual.Mutual;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.sign.RsaUtils;
import com.ruoyi.framework.topology.collect.CollectTopologyType;
import com.ruoyi.framework.topology.emnus.CollectTopology;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;

import javax.naming.Name;

/**
 * @author jianglw
 * @version 1.0
 * @date 2021/6/15 14:55
 */
@Component("publicInterface")
@Slf4j
public class PublicInterface {
    @Autowired
    private StringRedisTemplate stringRedisTemplate;

    public AjaxResult publicMethod(String id,String setterTag,String setteeTag) throws Exception{
        Integer ids;
        try {
            ids= Integer.parseInt( RsaUtils.decryptByPrivateKey( id ) );
        } catch (Exception e) {
            log.error(e.getLocalizedMessage());
            e.printStackTrace();
            log.error( "id解析失败" );
            return AjaxResult.error("id解析失败");
        }
        String value=stringRedisTemplate.opsForValue().get( Constants.TOPOLOGY_DATA+ids );
        if(StringUtils.isNotBlank( value )){
            JSONObject jsonObject=JSONObject.parseObject( value );
            JSONArray mutualList =jsonObject.getJSONArray( "mutualList" );
            for(int i=0;i<mutualList.size();i++){
                Mutual mutual=mutualList.getObject( i,Mutual.class );
                if(mutual.getSetter().equals( setterTag )&&mutual.getSettee().equals( setteeTag )){
                    CollectTopologyType collectTopologyType= CollectTopology.match(mutual.getDataAcquisitionMode());
                    assert collectTopologyType != null;
                    collectTopologyType.setData( mutual );
                }
            }

        }else{
            log.error( "未获取到组态数据" );
            return AjaxResult.error("未从redis中获取到组态数据");
        }

        return AjaxResult.success();
    }
}
