package com.ruoyi.framework.topology.collect;

import com.alibaba.fastjson.JSONArray;
import com.influxdb.client.InfluxDBClient;
import com.influxdb.client.WriteApi;
import com.influxdb.client.domain.WritePrecision;
import com.influxdb.client.write.Point;
import com.influxdb.query.FluxRecord;
import com.influxdb.query.FluxTable;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.topology.mutual.Mutual;
import com.ruoyi.common.utils.spring.SpringUtils;

import javax.management.Query;
import java.time.Instant;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author jianglw
 * @version 1.0
 * @date 2021/4/9 10:29
 */
public class InfluxdbType implements CollectTopologyType {

    InfluxDBClient influxDBClient= SpringUtils.getBean( "getInfluxDB" );

    @Override
    public Map<String,Object> getData(String param, JSONArray jsonArray) {
        List<FluxTable> list=influxDBClient.getQueryApi().query( param );
        Map<String,Object> map1=new LinkedHashMap<>(  );

        for(FluxTable fluxTable:list){
            List<FluxRecord> records = fluxTable.getRecords();
            for (FluxRecord fluxRecord : records) {
                map1.put( fluxRecord.getField(),fluxRecord.getValue() );
            }
        }
        return map1;
    }

    @Override
    public AjaxResult setData(Mutual mutual) {
        Map<String,Object> map=new LinkedHashMap<>(  );
        if(mutual.getAssignment().contains( "=" )){
            map.put( mutual.getPoint(),mutual.getAssignment().replaceAll( "=","" ) );
        }else{

        }
        Point point = Point
                .measurement(mutual.getCondition())
                .addFields( map )
                .time( Instant.now(), WritePrecision.NS);
        try (WriteApi writeApi = influxDBClient.getWriteApi()) {
            writeApi.writePoint(point);
        }
        return AjaxResult.success();
    }
}
