package com.ruoyi.framework.topology.collect;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.topology.mutual.Mutual;
import com.ruoyi.common.utils.JexlUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.spring.SpringUtils;
import org.springframework.data.redis.core.StringRedisTemplate;

import java.util.Map;

/**
 * @author jianglw
 * @version 1.0
 * @date 2021/4/9 9:57
 */
public class RedisType implements CollectTopologyType {

    private final StringRedisTemplate stringRedisTemplate = SpringUtils.getBean( StringRedisTemplate.class );
    @Override
    public Map<String,Object> getData(String param,JSONArray jsonArray) {
        String data =stringRedisTemplate.opsForValue().get( param );
        Map<String,Object> map= JSONObject.parseObject( data,Map.class );
        return map;
    }

    @Override
    public AjaxResult setData(Mutual mutual) {
        String str=stringRedisTemplate.opsForValue().get( mutual.getCondition() );
        if(StringUtils.isNotBlank( str )){
            JSONObject jsonObject=JSONObject.parseObject( str );
            if(mutual.getAssignment().contains( "=" )){
                jsonObject.put( mutual.getPoint(),mutual.getAssignment().replaceAll( "=","" ) );
            }else{
                jsonObject.put( mutual.getPoint(), JexlUtils.math(  jsonObject.getString( mutual.getPoint() )+mutual.getAssignment() ));
            }
            stringRedisTemplate.opsForValue().set( mutual.getCondition(),jsonObject.toJSONString() );
            return AjaxResult.success();
        }
        return AjaxResult.error("设置失败");
    }
}
