package com.ruoyi.framework.topology.collect;

import com.alibaba.fastjson.JSONArray;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.enums.NodeLineParams;
import com.ruoyi.common.topology.change.EchartsSet;
import com.ruoyi.common.topology.mutual.Mutual;
import com.ruoyi.common.utils.JexlUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.framework.topology.emnus.ShareDataType;
import com.ruoyi.common.topology.change.ChangeSub;
import com.ruoyi.common.topology.change.Handle;
import shareconnector.domain.DataType;
import shareconnector.netty.ShareServerFactory;
import shareconnector.service.SendAndRequestService;

import java.util.*;

/**
 * @author jianglw
 * @version 1.0
 * @date 2021/4/9 10:34
 */
public class ShareServerType implements CollectTopologyType {
    ShareServerFactory shareServerFactory=ShareServerFactory.getInstance();
    @Override
    public Map<String,Object> getData(String param, JSONArray jsonArray) {
        String[] params=param.split( ":" );
        shareServerFactory.setIp( params[0] ).setPort( Integer.parseInt( params[1] ) );
        List<ChangeSub> list=jsonArray.toJavaList( ChangeSub.class );
        Map<String, Set<Integer>> map =new LinkedHashMap<>(  );
        Set<Integer> set=null;
        for(ChangeSub changeSub:list) {
    //            #00FF00,#FF4500
//            true,false
            List<Handle> handleList = changeSub.getHandle();
            for(Handle handle:handleList){
                //获取echarts数据
                if(handle.getType().equals( NodeLineParams.DATA.type )){
                    for(EchartsSet echartsSet:handle.getEchartsArray()){
                        //echarts数据均为Float类型
                        if(map.containsKey( ShareDataType.FLOAT.name() )){
                            map.get( handle.getShareType() ).add( Integer.parseInt( echartsSet.getPoint() ) );
                        }else{
                            set=new LinkedHashSet<>(  );
                            set.add( Integer.parseInt( echartsSet.getPoint() ) );
                            map.put( ShareDataType.FLOAT.name(),set );
                        }
                    }
                //获取除echarts数据
                }else{
                    if(map.containsKey( handle.getShareType() )){
                        map.get( handle.getShareType() ).add( Integer.parseInt( handle.getPoint() ) );
                    }else{
                        set=new LinkedHashSet<>(  );
                        set.add( Integer.parseInt( handle.getPoint() ) );
                        map.put( handle.getShareType(),set );
                    }
                }

            }
        }
        Map<String,Object> map1=new LinkedHashMap<>(  );
        for(Map.Entry<String,Set<Integer>> setEntry:map.entrySet()){
            Map<Integer,Object> map2=SendAndRequestService.getInstance().getDatas(setEntry.getValue(), ShareDataType.match(setEntry.getKey())  );
            map1.put( setEntry.getKey(),map2 );
        }
        return  map1;
    }

    @Override
    public AjaxResult setData(Mutual mutual) {
        String[] params=mutual.getCondition().split( ":" );
        shareServerFactory.setIp( params[0] ).setPort( Integer.parseInt( params[1] ) );
        SendAndRequestService send=SendAndRequestService.getInstance();
        if(StringUtils.isNotBlank( mutual.getShareType() )){
            if(!mutual.getAssignment().contains( "=" )){
                if(mutual.getShareType().equals( ShareDataType.FLOAT.name())){
                    Set<Integer> set=new HashSet<>();
                    set.add( Integer.parseInt( mutual.getPoint() ) );
                    Map<Integer,Object> floatMap=send.getDatas( set, DataType.FLOAT );
                    Map<Integer,Float> map=new LinkedHashMap<>();
                    Float it=Float.parseFloat(JexlUtils.math( floatMap.get( Integer.parseInt( mutual.getPoint() ) )+mutual.getAssignment().replaceAll( "=","" ) ).toString()) ;
                    map.put( Integer.parseInt( mutual.getPoint() ), it);
                    send.sendFloatData( map );
                }
                if(mutual.getShareType().equals( ShareDataType.INT.name() )){
                    Set<Integer> set=new HashSet<>();
                    set.add( Integer.parseInt( mutual.getPoint() ) );
                    Map<Integer,Object> intMap=send.getDatas( set, DataType.INTEGER );
                    Map<Integer,Integer> map=new LinkedHashMap<>();
                    Integer it=Integer.parseInt(JexlUtils.math( intMap.get( Integer.parseInt( mutual.getPoint() ) )+mutual.getAssignment().replaceAll( "=","" ) ).toString()) ;
                    map.put( Integer.parseInt( mutual.getPoint() ),Integer.parseInt( mutual.getAssignment().replaceAll( "=","" ) ) );
                    send.sendIntegerData( map );
                }
            }else{
                if(mutual.getShareType().equals( ShareDataType.FLOAT.name())){
                    Map<Integer,Float> map=new LinkedHashMap<>();
                    map.put( Integer.parseInt( mutual.getPoint() ),Float.parseFloat( mutual.getAssignment().replaceAll( "=","" ) ) );
                    send.sendFloatData( map );
                }
                if(mutual.getShareType().equals( ShareDataType.BOOLEAN.name() )){
                    Map<Integer,Boolean> map=new LinkedHashMap<>();
                    map.put( Integer.parseInt( mutual.getPoint() ),Boolean.parseBoolean( mutual.getAssignment().replaceAll( "=","" ) ) );
                    send.sendBooleanData( map );
                }
                if(mutual.getShareType().equals( ShareDataType.INT.name() )){
                    Map<Integer,Integer> map=new LinkedHashMap<>();
                    map.put( Integer.parseInt( mutual.getPoint() ),Integer.parseInt( mutual.getAssignment().replaceAll( "=","" ) ) );
                    send.sendIntegerData( map );
                }
            }
        }
        return AjaxResult.success();
    }
}
